cern.colt.matrix.impl

## Class DenseObjectMatrix2D

- java.lang.Object
- - cern.colt.PersistentObject
  - - cern.colt.matrix.impl.AbstractMatrix
    - - cern.colt.matrix.impl.AbstractMatrix2D
      - - cern.colt.matrix.ObjectMatrix2D
        - - cern.colt.matrix.impl.DenseObjectMatrix2D

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public class DenseObjectMatrix2D
      extends ObjectMatrix2D

  Dense 2-d matrix holding `Object` elements. First see the package summary and javadoc tree view to get the broad picture.

  Implementation:

  Internally holds one single contigous one-dimensional array, addressed in row major. Note that this implementation is not synchronized.

  Memory requirements:

  `memory [bytes] = 8*rows()*columns()`. Thus, a 1000*1000 matrix uses 8 MB.

  Time complexity:

  `O(1)` (i.e. constant time) for the basic operations `get`, `getQuick`, `set`, `setQuick` and `size`,

  Cells are internally addressed in row-major. Applications demanding utmost speed can exploit this fact. Setting/getting values in a loop row-by-row is quicker than column-by-column. Thus

         for (int row=0; row < rows; row++) {
                for (int column=0; column < columns; column++) {
                       matrix.setQuick(row,column,someValue);
                }
         }

  is quicker than

         for (int column=0; column < columns; column++) {
                for (int row=0; row < rows; row++) {
                       matrix.setQuick(row,column,someValue);
                }
         }

  Version:
    1.0, 09/24/99
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class cern.colt.PersistentObject

      `serialVersionUID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DenseObjectMatrix2D(int rows, int columns)` Constructs a matrix with a given number of rows and columns.
    `DenseObjectMatrix2D(java.lang.Object[][] values)` Constructs a matrix with a copy of the given values.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ObjectMatrix2D` | `assign(java.lang.Object[][] values)` Sets all cells to the state specified by `values`.
    `ObjectMatrix2D` | `assign(ObjectFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.
    `ObjectMatrix2D` | `assign(ObjectMatrix2D source)` Replaces all cell values of the receiver with the values of another matrix.
    `ObjectMatrix2D` | `assign(ObjectMatrix2D y, ObjectObjectFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.
    `java.lang.Object` | `getQuick(int row, int column)` Returns the matrix cell value at coordinate `[row,column]`.
    `ObjectMatrix2D` | `like(int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns.
    `ObjectMatrix1D` | `like1D(int size)` Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver.
    `void` | `setQuick(int row, int column, java.lang.Object value)` Sets the matrix cell at coordinate `[row,column]` to the specified value.

    - ### Methods inherited from class cern.colt.matrix.ObjectMatrix2D

      `aggregate, aggregate, assign, cardinality, copy, equals, equals, get, getNonZeros, like, set, toArray, toString, viewColumn, viewColumnFlip, viewDice, viewPart, viewRow, viewRowFlip, viewSelection, viewSelection, viewSorted, viewStrides`

    - ### Methods inherited from class cern.colt.matrix.impl.AbstractMatrix2D

      `checkShape, checkShape, columns, rows, size, toStringShort`

    - ### Methods inherited from class cern.colt.matrix.impl.AbstractMatrix

      `ensureCapacity, trimToSize`

    - ### Methods inherited from class cern.colt.PersistentObject

      `clone`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DenseObjectMatrix2D

          public DenseObjectMatrix2D(java.lang.Object[][] values)

      Constructs a matrix with a copy of the given values. `values` is required to have the form `values[row][column]` and have exactly the same number of columns in every row.

      The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

      Parameters:
        `values` - The values to be filled into the new matrix.
      Throws:
        `java.lang.IllegalArgumentException` - if `for any 1 <= row < values.length: values[row].length != values[row-1].length`.

    - #### DenseObjectMatrix2D

          public DenseObjectMatrix2D(int rows,
                             int columns)

      Constructs a matrix with a given number of rows and columns. All entries are initially `0`.
      Parameters:
        `rows` - the number of rows the matrix shall have.
        `columns` - the number of columns the matrix shall have.
      Throws:
        `java.lang.IllegalArgumentException` - if `rows<0 || columns<0 || (Object)columns*rows > Integer.MAX_VALUE`.

  - ### Method Detail

    - #### assign

          public ObjectMatrix2D assign(java.lang.Object[][] values)

      Sets all cells to the state specified by `values`. `values` is required to have the form `values[row][column]` and have exactly the same number of rows and columns as the receiver.

      The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

      Overrides:
        `assign` in class `ObjectMatrix2D`
      Parameters:
        `values` - the values to be filled into the cells.
      Returns:
        `this` (for convenience only).
      Throws:
        `java.lang.IllegalArgumentException` - if `values.length != rows() || for any 0 <= row < rows(): values[row].length != columns()`.

    - #### assign

          public ObjectMatrix2D assign(ObjectFunction function)

      Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.

      Example:

          matrix = 2 x 2 matrix
          0.5 1.5
          2.5 3.5

          // change each cell to its sine
          matrix.assign(cern.jet.math.Functions.sin);
          -->
          2 x 2 matrix
          0.479426  0.997495
          0.598472 -0.350783

      For further examples, see the package doc.
      Overrides:
        `assign` in class `ObjectMatrix2D`
      Parameters:
        `function` - a function object taking as argument the current cell's value.
      Returns:
        `this` (for convenience only).
      See Also:
        `Functions`

    - #### assign

          public ObjectMatrix2D assign(ObjectMatrix2D source)

      Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same number of rows and columns. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.
      Overrides:
        `assign` in class `ObjectMatrix2D`
      Parameters:
        `source` - the source matrix to copy from (may be identical to the receiver).
      Returns:
        `this` (for convenience only).
      Throws:
        `java.lang.IllegalArgumentException` - if `columns() != source.columns() || rows() != source.rows()`

    - #### assign

          public ObjectMatrix2D assign(ObjectMatrix2D y,
                              ObjectObjectFunction function)

      Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.

      Example:

          // assign x[row,col] = x[row,col]y[row,col]
          m1 = 2 x 2 matrix
          0 1
          2 3

          m2 = 2 x 2 matrix
          0 2
          4 6

          m1.assign(m2, cern.jet.math.Functions.pow);
          -->
          m1 == 2 x 2 matrix
           1   1
          16 729

      For further examples, see the package doc.
      Overrides:
        `assign` in class `ObjectMatrix2D`
      Parameters:
        `y` - the secondary matrix to operate on.
        `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
      Returns:
        `this` (for convenience only).
      Throws:
        `java.lang.IllegalArgumentException` - if `columns() != other.columns() || rows() != other.rows()`
      See Also:
        `Functions`

    - #### getQuick

          public java.lang.Object getQuick(int row,
                                  int column)

      Returns the matrix cell value at coordinate `[row,column]`.

      Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

      Specified by:
        `getQuick` in class `ObjectMatrix2D`
      Parameters:
        `row` - the index of the row-coordinate.
        `column` - the index of the column-coordinate.
      Returns:
        the value at the specified coordinate.

    - #### like

          public ObjectMatrix2D like(int rows,
                            int columns)

      Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns. For example, if the receiver is an instance of type `DenseObjectMatrix2D` the new matrix must also be of type `DenseObjectMatrix2D`, if the receiver is an instance of type `SparseObjectMatrix2D` the new matrix must also be of type `SparseObjectMatrix2D`, etc. In general, the new matrix should have internal parametrization as similar as possible.
      Specified by:
        `like` in class `ObjectMatrix2D`
      Parameters:
        `rows` - the number of rows the matrix shall have.
        `columns` - the number of columns the matrix shall have.
      Returns:
        a new empty matrix of the same dynamic type.

    - #### like1D

          public ObjectMatrix1D like1D(int size)

      Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver. For example, if the receiver is an instance of type `DenseObjectMatrix2D` the new matrix must be of type `DenseObjectMatrix1D`, if the receiver is an instance of type `SparseObjectMatrix2D` the new matrix must be of type `SparseObjectMatrix1D`, etc.
      Specified by:
        `like1D` in class `ObjectMatrix2D`
      Parameters:
        `size` - the number of cells the matrix shall have.
      Returns:
        a new matrix of the corresponding dynamic type.

    - #### setQuick

          public void setQuick(int row,
                      int column,
                      java.lang.Object value)

      Sets the matrix cell at coordinate `[row,column]` to the specified value.

      Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

      Specified by:
        `setQuick` in class `ObjectMatrix2D`
      Parameters:
        `row` - the index of the row-coordinate.
        `column` - the index of the column-coordinate.
        `value` - the value to be filled into the specified cell.

Jump to the Colt Homepage